# encoding: utf-8
#
# WARNING: Do not edit by hand, this file was generated by Crank:
#
#   https://github.com/gocardless/crank
#
require 'uri'
require 'base64'

module GoCardless
  # GoCardless Enterprise API
  class ApiService
    # Initialize an APIService
    #
    # @param url [String] the URL to make requests to
    # @param key [String] the API Key ID to use
    # @param secret [String] the API key secret to use
    # @param options [Hash] additional options to use when creating the service
    def initialize(url, token, options = {})
      @url = url
      root_url, @path_prefix = unpack_url(url)
      http_adapter = options[:http_adapter] || [:net_http]
      @connection = Faraday.new(url: root_url) do |faraday|
        faraday.adapter(*http_adapter)
      end

      @headers = options[:default_headers] || {}
      @headers['Authorization'] = "Bearer #{token}"
    end

    # Make a request to the API
    #
    # @param method [Symbol] the method to use to make the request
    # @param path [String] the URL (without the base domain) to make the request to
    # @param options [Hash] the options hash - either the query parameters for a GET, or the body if POST/PUT
    # @param custom_headers [Hash] a hash of custom headers to use in the request
    def make_request(method, path, options = {}, custom_headers = {})
      fail ArgumentError, 'options must be a hash' unless options.is_a?(Hash)
      Request.new(@connection, method, @path_prefix + path, options, @headers.merge(custom_headers)).request
    end

    # inspect the API Service
    def inspect
      url = URI.parse(@url)
      url.password = 'REDACTED' unless url.password.nil?
      "#<GoCardless::Client url=\"#{url}\">"
    end
    alias_method :to_s, :inspect

    private

    def unpack_url(url)
      path = URI.parse(url).path
      [URI.join(url).to_s, path == '/' ? '' : path]
    end
  end
end
